#!/usr/bin/perl -w

# MTE Searcher was written by Cool Moe Di
# Mte Searcher wurde von Cool Moe Di geschrieben
# Copyright by Cool Moe Di

# ****************************************************************************************************************************************
# ****************************************************************************************************************************************
# *********************************************************** Optionen/Options ***********************************************************
# ****************************************************************************************************************************************
# ****************************************************************************************************************************************

# Kommentare
# Comments
$comments = "(\/\/|\{)";

# Zeichen, dass Steuerzeichen einleiten und beenden
# Symbol, that leads and ends commands
@symbols = ("\[", "\]");

# ****************************************************************************************************************************************
# ****************************************************************************************************************************************
# ****************************************************** Optionsende/End of Options ******************************************************
# ****************************************************************************************************************************************
# ****************************************************************************************************************************************


print "\n\n";
print "********************************************************************\n";
print "********************************************************************\n";
print "****************** Cool Moe Di's MTE Searcher **********************\n";
print "********************************************************************\n";
print "********************************************************************\n";

# Sprachwahl

print "\n\n\n\nChoose your language:\n(D)eutsch\n(E)nglish\n";
chomp($sprache = <STDIN>);

# berprfen der Sprache

if ($sprache eq "D" || $sprache eq "d" || $sprache eq "E" || $sprache eq "e")
        {
        # Deutsche Ausgabe
        if ($sprache eq "D" || $sprache eq "d")
                {
                $meldung1 = "Welche Datei soll durchsucht werden?";
                $meldung2 = "Konnte die Datei nicht oeffnen.";
                $meldung3 = "In welcher Datei soll die Ausgabe erfolgen?";
                $meldung4 = "Wie lange sollen die MTEs sein?";
                $meldung5 = "Wie viele MTEs sollen angezeigt werden?\nKeine Eingabe gibt alle aus.";
                $meldung6 = "Durchsuchen beendet!";
                $meldung7 = "Welche Warteroutine?\n(K)eine\n(F)liessend\n(D)rehend";
                }
        # Englische Ausgabe
        else
                {
                $meldung1 = "Which file should be worked on?";
                $meldung2 = "Can't open file.";
                $meldung3 = "In which file should I store the result?";
                $meldung4 = "How long should the MTEs be?";
                $meldung5 = "How many MTEs should I give you?\nNo input means all.";
                $meldung6 = "Search completed!";
                $meldung7 = "Which waiting routine?\n(N)one\n(F)loating\n(T)urning";
                }

        # Datei abfragen, die bearbeitet werden soll
        print "\n$meldung1\n";
        chomp($datei = <STDIN>);
        open(EIN, "< $datei")
                or
                die "\n$meldung2\n";

        # Datei abfragen, in die ausgegeben werden soll
        print "\n$meldung3\n";
        chomp($ausgabe = <STDIN>);
        open(AUS, "> $ausgabe")
                or
                die "\n$meldung2\n";

        # Optionen abfragen
        print "\n$meldung4\n";
        chomp($laenge = <STDIN>);
        print "\n$meldung5\n";
        chomp($anzahl = <STDIN>);
        print "\n$meldung7\n";
        chomp($modi = <STDIN>);

        # Textdatei durchsuchen
        $k = 0;
        $d = 0;
        $| = 1;
        while ($text = <EIN>)
                {
                $k++;
                if (($k % 200) == 0)
                        {
                        ausgabe();
                        }
                if ($text =~ m/$comments/)
                        {
                        }
                else
                        {
                        $text =~ s/\r\n/ /g;
                        $text =~ s/(\r\n|\n)//g;

                        $mte = "";
                        $status = 0;
                        while ($text =~ m/(.)/g)
                                {
                                $i = 0;
                                $on = 0;
                                $zeichen = $1;
                                $mte = "$mte$zeichen";
                                while ($mte =~ m/(.)/g)
                                        {
                                        $zaehl = $1;
                                        if ($zaehl eq $symbols[0])
                                                {
                                                $status = 1;
                                                $on = 1;
                                                }
                                        elsif ($zaehl eq $symbols[1] && $on == 0)
                                                {
                                                $status = 0;
                                                $i = 0;
                                                $on = 1;
                                                }
                                        elsif ($zaehl eq $symbols[1] && $on == 1)
                                                {
                                                $status = 0;
                                                }
                                        if ($status == 1)
                                                {
                                                $i--;
                                                }
                                        $i++;
                                        }
                                if ($i == $laenge)
                                        {
                                        $mtezahl{$mte}++;
                                        $mte =~ s/(.)//;
                                        }
                                else
                                        {
                                        }
                                }
                        }
                }

        # Ergebnisse auswerten

        $n = 0;
        foreach $key (sort { $mtezahl{$b} <=> $mtezahl{$a} } keys %mtezahl)
                {
                printf AUS "%5d x        \|$key\|\n", $mtezahl{$key};
                $n++;
                if ($anzahl ne "" && $n == $anzahl)
                        {
                        last;
                        }
                }



        # Beenden
        close(AUS);
        close(EIN);
        print "\n\n\n\t\t\t*******$meldung6*******\n\n\n\n";
        }
else
        {
        print "\nFalse input\nQuitting\n";
        }

sub ausgabe
        {
        if ($modi eq "F" || $modi eq "f")
                {
                print "-";
                }
        elsif ($modi eq "D" || $modi eq "d" || $modi eq "t" || $modi eq "T")
                {
                $d++;
                if ($d == 1)
                        {
                        print "\r\|";
                        }
                elsif ($d == 3)
                        {
                        print "\r\/";
                        }
                elsif ($d == 5)
                        {
                        print "\r\-";
                        }
                elsif ($d == 7)
                        {
                        print "\r\\";
                        }
                }
        else
                {
                }
        }